Index: /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c
===================================================================
--- /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 511)
+++ /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 512)
@@ -574,145 +692,175 @@
  * createProcess function: create a new process after setting some env variables
  */
-void createProcess(maps* m,map* request_inputs,service* s1,char* opts,int cpid, maps* inputs,maps* outputs){
+void
+createProcess (maps * m, map * request_inputs, service * s1, char *opts,
+               int cpid, maps * inputs, maps * outputs)
+{
   STARTUPINFO si;
   PROCESS_INFORMATION pi;
-  ZeroMemory( &si, sizeof(si) );
-  si.cb = sizeof(si);
-  ZeroMemory( &pi, sizeof(pi) );
-  char *tmp=(char *)malloc((1024+cgiContentLength)*sizeof(char));
-  char *tmpq=(char *)malloc((1024+cgiContentLength)*sizeof(char));
-  map *req=getMap(request_inputs,"request");
-  map *id=getMap(request_inputs,"identifier");
-  map *di=getMap(request_inputs,"DataInputs");
-
-  char *dataInputsKVP=getMapsAsKVP(inputs,cgiContentLength,0);
-  char *dataOutputsKVP=getMapsAsKVP(outputs,cgiContentLength,1);
-#ifdef DEBUG
-  fprintf(stderr,"DATAINPUTSKVP %s\n",dataInputsKVP);
-  fprintf(stderr,"DATAOUTPUTSKVP %s\n",dataOutputsKVP);
-#endif
-  map *sid=getMapFromMaps(m,"lenv","sid");
-  map* r_inputs=getMapFromMaps(m,"main","tmpPath");
-  map* r_inputs1=getMap(request_inputs,"metapath");
-  int hasIn=-1;
-  if(r_inputs1==NULL){
-    r_inputs1=createMap("metapath","");
-    hasIn=1;
-  }
-  map* r_inputs2=getMap(request_inputs,"ResponseDocument");
-  if(r_inputs2==NULL)
-    r_inputs2=getMap(request_inputs,"RawDataOutput");
-  map *tmpPath=getMapFromMaps(m,"lenv","cwd");
-
-  map *tmpReq=getMap(request_inputs,"xrequest");
-  if(r_inputs2!=NULL){
-    sprintf(tmp,"\"metapath=%s&request=%s&service=WPS&version=1.0.0&Identifier=%s&DataInputs=%s&%s=%s&cgiSid=%s\"",r_inputs1->value,req->value,id->value,dataInputsKVP,r_inputs2->name,dataOutputsKVP,sid->value);
-    sprintf(tmpq,"metapath=%s&request=%s&service=WPS&version=1.0.0&Identifier=%s&DataInputs=%s&%s=%s",r_inputs1->value,req->value,id->value,dataInputsKVP,r_inputs2->name,dataOutputsKVP);
-  }
-  else{
-    sprintf(tmp,"\"metapath=%s&request=%s&service=WPS&version=1.0.0&Identifier=%s&DataInputs=%s&cgiSid=%s\"",r_inputs1->value,req->value,id->value,dataInputsKVP,sid->value);
-    sprintf(tmpq,"metapath=%s&request=%s&service=WPS&version=1.0.0&Identifier=%s&DataInputs=%s",r_inputs1->value,req->value,id->value,dataInputsKVP,sid->value);
-  }
-  
-  if(hasIn>0){
-    freeMap(&r_inputs1);
-    free(r_inputs1);
-  }
-  char *tmp1=zStrdup(tmp);
-  sprintf(tmp,"\"zoo_loader.cgi\" %s \"%s\"",tmp1,sid->value);
-  
-  free(dataInputsKVP);
-  free(dataOutputsKVP);
-#ifdef DEBUG
-  fprintf(stderr,"REQUEST IS : %s \n",tmp);
-#endif
-  SetEnvironmentVariable("CGISID",TEXT(sid->value));
-  SetEnvironmentVariable("QUERY_STRING",TEXT(tmpq));
+  ZeroMemory (&si, sizeof (si));
+  si.cb = sizeof (si);
+  ZeroMemory (&pi, sizeof (pi));
+  char *tmp = (char *) malloc ((1024 + cgiContentLength) * sizeof (char));
+  char *tmpq = (char *) malloc ((1024 + cgiContentLength) * sizeof (char));
+  map *req = getMap (request_inputs, "request");
+  map *id = getMap (request_inputs, "identifier");
+  map *di = getMap (request_inputs, "DataInputs");
+
+  char *dataInputsKVP = getMapsAsKVP (inputs, cgiContentLength, 0);
+  char *dataOutputsKVP = getMapsAsKVP (outputs, cgiContentLength, 1);
+#ifdef DEBUG
+  fprintf (stderr, "DATAINPUTSKVP %s\n", dataInputsKVP);
+  fprintf (stderr, "DATAOUTPUTSKVP %s\n", dataOutputsKVP);
+#endif
+  map *sid = getMapFromMaps (m, "lenv", "sid");
+  map *r_inputs = getMapFromMaps (m, "main", "tmpPath");
+  map *r_inputs1 = getMap (request_inputs, "metapath");
+  int hasIn = -1;
+  if (r_inputs1 == NULL)
+    {
+      r_inputs1 = createMap ("metapath", "");
+      hasIn = 1;
+    }
+  map *r_inputs2 = getMap (request_inputs, "ResponseDocument");
+  if (r_inputs2 == NULL)
+    r_inputs2 = getMap (request_inputs, "RawDataOutput");
+  map *tmpPath = getMapFromMaps (m, "lenv", "cwd");
+
+  map *tmpReq = getMap (request_inputs, "xrequest");
+  if (r_inputs2 != NULL)
+    {
+      sprintf (tmp,
+               "\"metapath=%s&request=%s&service=WPS&version=1.0.0&Identifier=%s&DataInputs=%s&%s=%s&cgiSid=%s\"",
+               r_inputs1->value, req->value, id->value, dataInputsKVP,
+               r_inputs2->name, dataOutputsKVP, sid->value);
+      sprintf (tmpq,
+               "metapath=%s&request=%s&service=WPS&version=1.0.0&Identifier=%s&DataInputs=%s&%s=%s",
+               r_inputs1->value, req->value, id->value, dataInputsKVP,
+               r_inputs2->name, dataOutputsKVP);
+    }
+  else
+    {
+      sprintf (tmp,
+               "\"metapath=%s&request=%s&service=WPS&version=1.0.0&Identifier=%s&DataInputs=%s&cgiSid=%s\"",
+               r_inputs1->value, req->value, id->value, dataInputsKVP,
+               sid->value);
+      sprintf (tmpq,
+               "metapath=%s&request=%s&service=WPS&version=1.0.0&Identifier=%s&DataInputs=%s",
+               r_inputs1->value, req->value, id->value, dataInputsKVP,
+               sid->value);
+    }
+
+  if (hasIn > 0)
+    {
+      freeMap (&r_inputs1);
+      free (r_inputs1);
+    }
+  char *tmp1 = zStrdup (tmp);
+  sprintf (tmp, "\"zoo_loader.cgi\" %s \"%s\"", tmp1, sid->value);
+
+  free (dataInputsKVP);
+  free (dataOutputsKVP);
+#ifdef DEBUG
+  fprintf (stderr, "REQUEST IS : %s \n", tmp);
+#endif
+  SetEnvironmentVariable ("CGISID", TEXT (sid->value));
+  SetEnvironmentVariable ("QUERY_STRING", TEXT (tmpq));
   char clen[1000];
-  sprintf(clen,"%d",strlen(tmpq));
-  SetEnvironmentVariable("CONTENT_LENGTH",TEXT(clen));
-  
-  if( !CreateProcess( NULL,             // No module name (use command line)
-		      TEXT(tmp),        // Command line
-		      NULL,             // Process handle not inheritable
-		      NULL,             // Thread handle not inheritable
-		      FALSE,            // Set handle inheritance to FALSE
-		      CREATE_NO_WINDOW, // Apache won't wait until the end
-		      NULL,             // Use parent's environment block
-		      NULL,             // Use parent's starting directory 
-		      &si,              // Pointer to STARTUPINFO struct
-		      &pi )             // Pointer to PROCESS_INFORMATION struct
-      ) 
-    { 
-#ifdef DEBUG
-      fprintf( stderr, "CreateProcess failed (%d).\n", GetLastError() );
-#endif
-      return ;
-    }else{
-#ifdef DEBUG
-    fprintf( stderr, "CreateProcess successfull (%d).\n\n\n\n", GetLastError() );
-#endif
-  }
-  CloseHandle( pi.hProcess );
-  CloseHandle( pi.hThread );
-#ifdef DEBUG
-  fprintf(stderr,"CreateProcess finished !\n");
+  sprintf (clen, "%d", strlen (tmpq));
+  SetEnvironmentVariable ("CONTENT_LENGTH", TEXT (clen));
+
+  if (!CreateProcess (NULL,     // No module name (use command line)
+                      TEXT (tmp),       // Command line
+                      NULL,     // Process handle not inheritable
+                      NULL,     // Thread handle not inheritable
+                      FALSE,    // Set handle inheritance to FALSE
+                      CREATE_NO_WINDOW, // Apache won't wait until the end
+                      NULL,     // Use parent's environment block
+                      NULL,     // Use parent's starting directory 
+                      &si,      // Pointer to STARTUPINFO struct
+                      &pi)      // Pointer to PROCESS_INFORMATION struct
+    )
+    {
+#ifdef DEBUG
+      fprintf (stderr, "CreateProcess failed (%d).\n", GetLastError ());
+#endif
+      return;
+    }
+  else
+    {
+#ifdef DEBUG
+      fprintf (stderr, "CreateProcess successfull (%d).\n\n\n\n",
+               GetLastError ());
+#endif
+    }
+  CloseHandle (pi.hProcess);
+  CloseHandle (pi.hThread);
+#ifdef DEBUG
+  fprintf (stderr, "CreateProcess finished !\n");
 #endif
 }
 #endif
 
-int runRequest(map** inputs)
+int
+runRequest (map ** inputs)
 {
-  
+
 #ifndef USE_GDB
-  (void) signal(SIGSEGV,sig_handler);
-  (void) signal(SIGTERM,sig_handler);
-  (void) signal(SIGINT,sig_handler);
-  (void) signal(SIGILL,sig_handler);
-  (void) signal(SIGFPE,sig_handler);
-  (void) signal(SIGABRT,sig_handler);
-#endif
-
-  map* r_inputs=NULL;
-  map* request_inputs=*inputs;
-  maps* m=NULL;
-  char* REQUEST=NULL;
+  (void) signal (SIGSEGV, sig_handler);
+  (void) signal (SIGTERM, sig_handler);
+  (void) signal (SIGINT, sig_handler);
+  (void) signal (SIGILL, sig_handler);
+  (void) signal (SIGFPE, sig_handler);
+  (void) signal (SIGABRT, sig_handler);
+#endif
+
+  map *r_inputs = NULL;
+  map *request_inputs = *inputs;
+  maps *m = NULL;
+  char *REQUEST = NULL;
   /**
    * Parsing service specfic configuration file
    */
-  m=(maps*)malloc(MAPS_SIZE);
-  if(m == NULL){
-    return errorException(m, _("Unable to allocate memory."), "InternalError",NULL);
-  }
+  m = (maps *) malloc (MAPS_SIZE);
+  if (m == NULL)
+    {
+      return errorException (m, _("Unable to allocate memory."),
+                             "InternalError", NULL);
+    }
   char ntmp[1024];
 #ifndef WIN32
-  getcwd(ntmp,1024);
+  getcwd (ntmp, 1024);
 #else
-  _getcwd(ntmp,1024);
-#endif
-  r_inputs=getMapOrFill(&request_inputs,"metapath","");
+  _getcwd (ntmp, 1024);
+#endif
+  r_inputs = getMapOrFill (&request_inputs, "metapath", "");
 
 
   char conf_file[10240];
-  snprintf(conf_file,10240,"%s/%s/main.cfg",ntmp,r_inputs->value);
-  if(conf_read(conf_file,m)==2){
-    errorException(NULL, _("Unable to load the main.cfg file."),"InternalError",NULL);
-    free(m);
-    return 1;
-  }
-#ifdef DEBUG
-  fprintf(stderr, "***** BEGIN MAPS\n"); 
-  dumpMaps(m);
-  fprintf(stderr, "***** END MAPS\n");
-#endif
-
-  map *getPath=getMapFromMaps(m,"main","gettextPath");
-  if(getPath!=NULL){
-    bindtextdomain ("zoo-kernel",getPath->value);
-    bindtextdomain ("zoo-services",getPath->value);    
-  }else{
-    bindtextdomain ("zoo-kernel","/usr/share/locale/");
-    bindtextdomain ("zoo-services","/usr/share/locale/");
-  }
+  snprintf (conf_file, 10240, "%s/%s/main.cfg", ntmp, r_inputs->value);
+  if (conf_read (conf_file, m) == 2)
+    {
+      errorException (NULL, _("Unable to load the main.cfg file."),
+                      "InternalError", NULL);
+      free (m);
+      return 1;
+    }
+#ifdef DEBUG
+  fprintf (stderr, "***** BEGIN MAPS\n");
+  dumpMaps (m);
+  fprintf (stderr, "***** END MAPS\n");
+#endif
+
+  map *getPath = getMapFromMaps (m, "main", "gettextPath");
+  if (getPath != NULL)
+    {
+      bindtextdomain ("zoo-kernel", getPath->value);
+      bindtextdomain ("zoo-services", getPath->value);
+    }
+  else
+    {
+      bindtextdomain ("zoo-kernel", "/usr/share/locale/");
+      bindtextdomain ("zoo-services", "/usr/share/locale/");
+    }
 
 
@@ -722,169 +870,212 @@
    * headers messages returned by the CGI due to wrong redirection of stderr)
    */
-  FILE * fstde=NULL;
-  map* fstdem=getMapFromMaps(m,"main","logPath");
-  if(fstdem!=NULL)
-    fstde = freopen(fstdem->value, "a+", stderr) ;
-
-  r_inputs=getMap(request_inputs,"language");
-  if(r_inputs==NULL)
-    r_inputs=getMapFromMaps(m,"main","language");
-  if(r_inputs!=NULL){
-    if(isValidLang(m,r_inputs->value)<0){
-      char tmp[1024];
-      sprintf(tmp,_("The value %s is not supported for the <language> parameter"),
-	      r_inputs->value);
-      errorException(m, tmp,"InvalidParameterValue","language");
-      freeMaps(&m);
-      free(m);
-      free(REQUEST);
-      return 1;
-
-    }
-    char *tmp=zStrdup(r_inputs->value);
-    setMapInMaps(m,"main","language",tmp);
+  FILE *fstde = NULL;
+  map *fstdem = getMapFromMaps (m, "main", "logPath");
+  if (fstdem != NULL)
+    fstde = freopen (fstdem->value, "a+", stderr);
+
+  r_inputs = getMap (request_inputs, "language");
+  if (r_inputs == NULL)
+    r_inputs = getMapFromMaps (m, "main", "language");
+  if (r_inputs != NULL)
+    {
+      if (isValidLang (m, r_inputs->value) < 0)
+        {
+          char tmp[1024];
+          sprintf (tmp,
+                   _
+                   ("The value %s is not supported for the <language> parameter"),
+                   r_inputs->value);
+          errorException (m, tmp, "InvalidParameterValue", "language");
+          freeMaps (&m);
+          free (m);
+          free (REQUEST);
+          return 1;
+
+        }
+      char *tmp = zStrdup (r_inputs->value);
+      setMapInMaps (m, "main", "language", tmp);
 #ifdef DEB
-    char tmp2[12];
-    sprintf(tmp2,"%s.utf-8",tmp);
-    translateChar(tmp2,'-','_');
-    setlocale (LC_ALL, tmp2);
+      char tmp2[12];
+      sprintf (tmp2, "%s.utf-8", tmp);
+      translateChar (tmp2, '-', '_');
+      setlocale (LC_ALL, tmp2);
 #else
-    translateChar(tmp,'-','_');
-    setlocale (LC_ALL, tmp);
+      translateChar (tmp, '-', '_');
+      setlocale (LC_ALL, tmp);
 #endif
 #ifndef WIN32
-    setenv("LC_ALL",tmp,1);
+      setenv ("LC_ALL", tmp, 1);
 #else
-    char tmp1[12];
-    sprintf(tmp1,"LC_ALL=%s",tmp);
-    putenv(tmp1);
-#endif
-    free(tmp);
-  }
-  else{
-    setlocale (LC_ALL, "en_US");
+      char tmp1[12];
+      sprintf (tmp1, "LC_ALL=%s", tmp);
+      putenv (tmp1);
+#endif
+      free (tmp);
+    }
+  else
+    {
+      setlocale (LC_ALL, "en_US");
 #ifndef WIN32
-    setenv("LC_ALL","en_US",1);
+      setenv ("LC_ALL", "en_US", 1);
 #else
-    char tmp1[12];
-    sprintf(tmp1,"LC_ALL=en_US");
-    putenv(tmp1);
-#endif
-    setMapInMaps(m,"main","language","en-US");
-  }
+      char tmp1[12];
+      sprintf (tmp1, "LC_ALL=en_US");
+      putenv (tmp1);
+#endif
+      setMapInMaps (m, "main", "language", "en-US");
+    }
   setlocale (LC_NUMERIC, "en_US");
-  bind_textdomain_codeset("zoo-kernel","UTF-8");
-  textdomain("zoo-kernel");
-  bind_textdomain_codeset("zoo-services","UTF-8");
-  textdomain("zoo-services");
-
-  map* lsoap=getMap(request_inputs,"soap");
-  if(lsoap!=NULL && strcasecmp(lsoap->value,"true")==0)
-    setMapInMaps(m,"main","isSoap","true");
+  bind_textdomain_codeset ("zoo-kernel", "UTF-8");
+  textdomain ("zoo-kernel");
+  bind_textdomain_codeset ("zoo-services", "UTF-8");
+  textdomain ("zoo-services");
+
+  map *lsoap = getMap (request_inputs, "soap");
+  if (lsoap != NULL && strcasecmp (lsoap->value, "true") == 0)
+    setMapInMaps (m, "main", "isSoap", "true");
   else
-    setMapInMaps(m,"main","isSoap","false");
-
-  if(strlen(cgiServerName)>0){
-    char tmpUrl[1024];
-    if(strncmp(cgiServerPort,"80",2)==0){
-      sprintf(tmpUrl,"http://%s%s",cgiServerName,cgiScriptName);
-    }else{
-      sprintf(tmpUrl,"http://%s:%s%s",cgiServerName,cgiServerPort,cgiScriptName);
-    }
-#ifdef DEBUG
-    fprintf(stderr,"*** %s ***\n",tmpUrl);
-#endif
-    setMapInMaps(m,"main","serverAddress",tmpUrl);
-  }
+    setMapInMaps (m, "main", "isSoap", "false");
+
+  if (strlen (cgiServerName) > 0)
+    {
+      char tmpUrl[1024];
+      if (strncmp (cgiServerPort, "80", 2) == 0)
+        {
+          sprintf (tmpUrl, "http://%s%s", cgiServerName, cgiScriptName);
+        }
+      else
+        {
+          sprintf (tmpUrl, "http://%s:%s%s", cgiServerName, cgiServerPort,
+                   cgiScriptName);
+        }
+#ifdef DEBUG
+      fprintf (stderr, "*** %s ***\n", tmpUrl);
+#endif
+      setMapInMaps (m, "main", "serverAddress", tmpUrl);
+    }
 
   /**
    * Check for minimum inputs
    */
-  r_inputs=getMap(request_inputs,"Request");
-  if(request_inputs==NULL || r_inputs==NULL){ 
-    errorException(m, _("Parameter <request> was not specified"),"MissingParameterValue","request");
-    if(count(request_inputs)==1){
-      freeMap(&request_inputs);
-      free(request_inputs);
-    }
-    freeMaps(&m);
-    free(m);
-    return 1;
-  }
-  else{
-    REQUEST=zStrdup(r_inputs->value);
-    if(strncasecmp(r_inputs->value,"GetCapabilities",15)!=0
-       && strncasecmp(r_inputs->value,"DescribeProcess",15)!=0
-       && strncasecmp(r_inputs->value,"Execute",7)!=0){ 
-      errorException(m, _("Unenderstood <request> value. Please check that it was set to GetCapabilities, DescribeProcess or Execute."), "OperationNotSupported",r_inputs->value);
-      freeMaps(&m);
-      free(m);
-      free(REQUEST);
+  r_inputs = getMap (request_inputs, "Request");
+  if (request_inputs == NULL || r_inputs == NULL)
+    {
+      errorException (m, _("Parameter <request> was not specified"),
+                      "MissingParameterValue", "request");
+      if (count (request_inputs) == 1)
+        {
+          freeMap (&request_inputs);
+          free (request_inputs);
+        }
+      freeMaps (&m);
+      free (m);
       return 1;
     }
-  }
-  r_inputs=NULL;
-  r_inputs=getMap(request_inputs,"Service");
-  if(r_inputs==NULLMAP){
-    errorException(m, _("Parameter <service> was not specified"),"MissingParameterValue","service");
-    freeMaps(&m);
-    free(m);
-    free(REQUEST);
-    return 1;
-  }else{
-    if(strcasecmp(r_inputs->value,"WPS")!=0){
-      errorException(m, _("Unenderstood <service> value, WPS is the only acceptable value."), "InvalidParameterValue","service");
-      freeMaps(&m);
-      free(m);
-      free(REQUEST);
+  else
+    {
+      REQUEST = zStrdup (r_inputs->value);
+      if (strncasecmp (r_inputs->value, "GetCapabilities", 15) != 0
+          && strncasecmp (r_inputs->value, "DescribeProcess", 15) != 0
+          && strncasecmp (r_inputs->value, "Execute", 7) != 0)
+        {
+          errorException (m,
+                          _
+                          ("Unenderstood <request> value. Please check that it was set to GetCapabilities, DescribeProcess or Execute."),
+                          "OperationNotSupported", r_inputs->value);
+          freeMaps (&m);
+          free (m);
+          free (REQUEST);
+          return 1;
+        }
+    }
+  r_inputs = NULL;
+  r_inputs = getMap (request_inputs, "Service");
+  if (r_inputs == NULLMAP)
+    {
+      errorException (m, _("Parameter <service> was not specified"),
+                      "MissingParameterValue", "service");
+      freeMaps (&m);
+      free (m);
+      free (REQUEST);
       return 1;
     }
-  }
-  if(strncasecmp(REQUEST,"GetCapabilities",15)!=0){
-    r_inputs=getMap(request_inputs,"Version");
-    if(r_inputs==NULL){ 
-      errorException(m, _("Parameter <version> was not specified"),"MissingParameterValue","version");
-      freeMaps(&m);
-      free(m);
-      free(REQUEST);
-      return 1;
-    }else{
-      if(strcasecmp(r_inputs->value,"1.0.0")!=0){
-	errorException(m, _("Unenderstood <version> value, 1.0.0 is the only acceptable value."), "InvalidParameterValue","service");
-	freeMaps(&m);
-	free(m);
-	free(REQUEST);
-	return 1;
-      }
-    } 
-  }else{
-    r_inputs=getMap(request_inputs,"AcceptVersions");
-    if(r_inputs!=NULL){ 
-      if(strncmp(r_inputs->value,"1.0.0",5)!=0){
-	errorException(m, _("Unenderstood <AcceptVersions> value, 1.0.0 is the only acceptable value."), "VersionNegotiationFailed",NULL);
-	freeMaps(&m);
-	free(m);
-	free(REQUEST);
-	return 1;
-      }
-    }
-  }
-
-  r_inputs=getMap(request_inputs,"serviceprovider");
-  if(r_inputs==NULL){
-    addToMap(request_inputs,"serviceprovider","");
-  }
-
-  maps* request_output_real_format=NULL;
-  map* tmpm=getMapFromMaps(m,"main","serverAddress");
-  if(tmpm!=NULL)
-    SERVICE_URL=zStrdup(tmpm->value);
   else
-    SERVICE_URL=zStrdup(DEFAULT_SERVICE_URL);
-
-  service* s1;
-  int scount=0;
-#ifdef DEBUG
-  dumpMap(r_inputs);
+    {
+      if (strcasecmp (r_inputs->value, "WPS") != 0)
+        {
+          errorException (m,
+                          _
+                          ("Unenderstood <service> value, WPS is the only acceptable value."),
+                          "InvalidParameterValue", "service");
+          freeMaps (&m);
+          free (m);
+          free (REQUEST);
+          return 1;
+        }
+    }
+  if (strncasecmp (REQUEST, "GetCapabilities", 15) != 0)
+    {
+      r_inputs = getMap (request_inputs, "Version");
+      if (r_inputs == NULL)
+        {
+          errorException (m, _("Parameter <version> was not specified"),
+                          "MissingParameterValue", "version");
+          freeMaps (&m);
+          free (m);
+          free (REQUEST);
+          return 1;
+        }
+      else
+        {
+          if (strcasecmp (r_inputs->value, "1.0.0") != 0)
+            {
+              errorException (m,
+                              _
+                              ("Unenderstood <version> value, 1.0.0 is the only acceptable value."),
+                              "InvalidParameterValue", "service");
+              freeMaps (&m);
+              free (m);
+              free (REQUEST);
+              return 1;
+            }
+        }
+    }
+  else
+    {
+      r_inputs = getMap (request_inputs, "AcceptVersions");
+      if (r_inputs != NULL)
+        {
+          if (strncmp (r_inputs->value, "1.0.0", 5) != 0)
+            {
+              errorException (m,
+                              _
+                              ("Unenderstood <AcceptVersions> value, 1.0.0 is the only acceptable value."),
+                              "VersionNegotiationFailed", NULL);
+              freeMaps (&m);
+              free (m);
+              free (REQUEST);
+              return 1;
+            }
+        }
+    }
+
+  r_inputs = getMap (request_inputs, "serviceprovider");
+  if (r_inputs == NULL)
+    {
+      addToMap (request_inputs, "serviceprovider", "");
+    }
+
+  maps *request_output_real_format = NULL;
+  map *tmpm = getMapFromMaps (m, "main", "serverAddress");
+  if (tmpm != NULL)
+    SERVICE_URL = zStrdup (tmpm->value);
+  else
+    SERVICE_URL = zStrdup (DEFAULT_SERVICE_URL);
+
+  service *s1;
+  int scount = 0;
+#ifdef DEBUG
+  dumpMap (r_inputs);
 #endif
   char conf_dir[1024];
